//
//  OCEMath.m
//  InfiniteCanvas
//
//  Created by Markus Mueller <markus@mindnode.com>.
//	http://www.infinitecanvas.com/
//  Copyright (c) 2003-2005 Markus Mueller. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//  
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//  
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//  

#import "OCEMath.h"


@implementation OCEMath
+ (float) calculateDegreesVector1: (NSPoint) a vector2: (NSPoint) b
{
    // Formel
    // (a * b) / (|a| * |b|) = cos() => winkelmass zweier vektorn
    
    // (a*b)
    float numerator = a.x*b.x+a.y*b.y; // b=1
    
    // |a| * |b|
    float denominator = sqrt(a.x*a.x+a.y*a.y)*sqrt(b.x*b.x+b.y*b.y); // b=1
    float x = numerator / denominator;
    
    float result = acos(x)*180/M_PI;
    
    if (a.y > b.y)
        result = 360-result;
    
   return result;
}
@end
