//
//  OCETrailArrowPreview.m
//  InfiniteCanvas
//
//  Created by Markus Mueller <markus@mindnode.com>.
//	http://www.infinitecanvas.com/
//  Copyright (c) 2003-2005 Markus Mueller. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//  
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//  
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//  

#import "OCETrailArrowPreview.h"
#import "OCEWindowController.h"
#import "OCECanvas.h"
#import "OCEDocument.h"
#import "NSBezierPathHitTest.h"


@implementation OCETrailArrowPreview

- (id)init 
{
    [super init];
    type = 9999;
    return self;
}

- (id)initWithFrame:(NSRect)frame {
    self = [super initWithFrame:frame];
    if (self) {
        path = nil;
		arrowPath = nil;
        [self setType:0];
        color = [[NSColor blackColor] retain];
        thickness = 3;
        //image = nil;
        //rotateImage = nil;
        //dragging = NO; 
        //imageDrawRect = NSZeroRect;
        [self registerForDraggedTypes:[NSArray arrayWithObjects: NSFilenamesPboardType,nil]];
		
		offset=0;
    }
    return self;
}

- (void)drawRect:(NSRect)rect 
{
    [NSBezierPath setDefaultLineCapStyle:NSRoundLineCapStyle];
	[NSBezierPath setDefaultLineJoinStyle:NSRoundLineJoinStyle];
    [color set];
    [path stroke];
	[arrowPath stroke];
	/*
    if (((type == 4) || (type == 6)) && (image))
    {	
        [image drawInRect: NSMakeRect(31,0,24,24) 
            fromRect: NSMakeRect(0,0,24,24) 
            operation:NSCompositeSourceOver 
            fraction:1.0];
    }	
    
    if (((type == 5) || (type == 6)) && (rotateImage))
    {
        [rotateImage drawInRect:NSMakeRect(5,0,24,24)
                fromRect:NSMakeRect(0,0,24,24) 
                operation:NSCompositeSourceOver 
                fraction:1.0];
    }*/
        
    /*if (dragging) 
    {
        [[NSColor darkGrayColor] set];
        [NSBezierPath setDefaultLineWidth: 5];
        [NSBezierPath strokeRect: rect];
    }*/         
}


- (void)setWindowController:(OCEWindowController *)aController
{
    controller = aController;
}


- (void) setType: (int) newType
{
    //if (type == newType)
      //  return;
        
    type = newType;
    [path release];
	[arrowPath release];
	
    path = [[NSBezierPath bezierPath] retain];
	arrowPath = [[NSBezierPath bezierPath] retain];

	
    NSPoint startPoint = NSMakePoint(5,12);
    NSPoint endPoint = NSMakePoint(55,12);
    [path moveToPoint:NSMakePoint(startPoint.x,startPoint.y)];
    [path lineToPoint: endPoint];   

    switch (type)
    {
        case 3:
        {
            [arrowPath moveToPoint:NSMakePoint(startPoint.x+10,startPoint.y-10)];
            [arrowPath lineToPoint:startPoint];
            [arrowPath lineToPoint:NSMakePoint(startPoint.x+10,startPoint.y+10)];
        }
        case 1:
        {
            [arrowPath moveToPoint:NSMakePoint(endPoint.x-10,endPoint.y+10)];
            [arrowPath lineToPoint:endPoint];
            [arrowPath lineToPoint:NSMakePoint(endPoint.x-10,endPoint.y-10)];
            break;
        }
        case 2:
        {
            [arrowPath moveToPoint:NSMakePoint(startPoint.x+10,startPoint.y-10)];
            [arrowPath lineToPoint:startPoint];
            [arrowPath lineToPoint:NSMakePoint(startPoint.x+10,startPoint.y+10)];
			break;
        }
		case 6:
        {
            [arrowPath moveToPoint:NSMakePoint(startPoint.x+15,startPoint.y-7)];
            [arrowPath lineToPoint:startPoint];
            [arrowPath lineToPoint:NSMakePoint(startPoint.x+15,startPoint.y+7)];
			[arrowPath moveToPoint:NSMakePoint(startPoint.x+15,startPoint.y+7)]; // workaround
            [arrowPath lineToPoint:NSMakePoint(startPoint.x+5,startPoint.y)];
            [arrowPath lineToPoint:NSMakePoint(startPoint.x+15,startPoint.y-7)];
        }
        case 4:
        {
            [arrowPath moveToPoint:NSMakePoint(endPoint.x-15,endPoint.y+7)];
            [arrowPath lineToPoint:endPoint];
            [arrowPath lineToPoint:NSMakePoint(endPoint.x-15,endPoint.y-7)];
			[arrowPath moveToPoint:NSMakePoint(endPoint.x-15,endPoint.y+7)]; // workaround
            [arrowPath lineToPoint:NSMakePoint(endPoint.x-5,endPoint.y)];
            [arrowPath lineToPoint:NSMakePoint(endPoint.x-15,endPoint.y-7)];			
            break;
        }
        case 5:
        {
            [arrowPath moveToPoint:NSMakePoint(startPoint.x+15,startPoint.y-7)];
            [arrowPath lineToPoint:startPoint];
            [arrowPath lineToPoint:NSMakePoint(startPoint.x+15,startPoint.y+7)];
			[arrowPath moveToPoint:NSMakePoint(startPoint.x+15,startPoint.y+7)]; // workaround
            [arrowPath lineToPoint:NSMakePoint(startPoint.x+5,startPoint.y)];
            [arrowPath lineToPoint:NSMakePoint(startPoint.x+15,startPoint.y-7)];			
			break;
        }
    }

    [path setLineWidth: thickness];
    [arrowPath setLineWidth: thickness];
    [self setNeedsDisplay:YES];
}

- (int) type
{
    return type;
}

/*- (void) setImage: (NSImage *) newImage andRotateImage: (NSImage *) newRotateImage; 
{
    id oldImage = image;
    image = [newImage retain];
    [oldImage release];
    
    id oldRotateImage = rotateImage;
    rotateImage = [newRotateImage retain];
    [oldRotateImage release];
    
    [self setNeedsDisplay:YES];
}*/

- (void) setOtherView: (OCETrailArrowPreview *) anOtherView
{
    otherView = anOtherView;
}

- (void) setThickness: (float) newThickness
{
    if (thickness != newThickness)
    {
        thickness = newThickness;
        [path setLineWidth:thickness];
		[arrowPath setLineWidth:thickness];

        [self setNeedsDisplay:YES];
    }
}

- (void) setColor: (NSColor *) newColor
{
    id oldColor = color;
    color = [newColor retain];
    [oldColor release];
    [self setNeedsDisplay:YES];
}

// i want to respond to events
- (BOOL)acceptsFirstResponder {
    return YES;
}

// wenn man auf den view klickt bewegt sich nicht das fenster mit
- (BOOL)mouseDownCanMoveWindow {
    return NO;
}

- (void)dealloc {
    //[image release];
    //[rotateImage release];
    [color release];
	[path release];
	[arrowPath release];
    [super dealloc];
}

// ----------------------------------------------------------------------
// DRAG DESTINATION METHODS
// ----------------------------------------------------------------------
// curser setzen
/*- (NSDragOperation)draggingEntered:(id <NSDraggingInfo>)sender 
{
    if (type < 3)
        return NO;

    NSPasteboard *pboard;
    NSDragOperation sourceDragMask;

    sourceDragMask = [sender draggingSourceOperationMask];
    pboard = [sender draggingPasteboard];
	
    if ( [[pboard types] containsObject:NSFilenamesPboardType] ) 
	{
        if (sourceDragMask & NSDragOperationLink) {
			NSString *dropPath = [[pboard propertyListForType:NSFilenamesPboardType] objectAtIndex:0];
			dropPath = [dropPath pathExtension];
			if (([dropPath isEqualToString: @"gif"]) || ([dropPath isEqualToString: @"jpg"]) ||
				([dropPath isEqualToString: @"jpeg"])) {
				dragging = YES;
				[self setNeedsDisplay:YES];
				return NSDragOperationLink;
			}
        }
    }
    return NSDragOperationNone;
}*/

/*- (void)draggingExited:(id <NSDraggingInfo>)sender
{
    dragging = NO;
    [self setNeedsDisplay:YES];
}*/

// ja, ich bin bereit :)
/*- (BOOL)prepareForDragOperation:(id <NSDraggingInfo>)sender
{
    dragging=NO;
    return YES;
}*/

// drag operation durchfhren 
/*- (BOOL)performDragOperation:(id <NSDraggingInfo>)sender
{
    NSPasteboard *pasteBoard = [sender draggingPasteboard];

    if ( [[pasteBoard types] containsObject:NSFilenamesPboardType] ) 
    {
        NSArray *files = [pasteBoard propertyListForType:NSFilenamesPboardType];
        if (![files count])
            return NO;
            
        [controller setArrowImageWithPath: [files objectAtIndex:0]];
    
        return YES;
    }
    return NO; // keine passenden filetypen gefunden
}*/

// ----------------------------------------------------------------------
// EVENT HANDEL METHODS
// ----------------------------------------------------------------------
- (void)mouseDown:(NSEvent *)theEvent
{
    if([theEvent clickCount] == 2)
    {
        switch (type)
        {
            case 1:
                [self setType: 2];
                break;
            case 2:
                [self setType: 1];
                break;
            case 4:
                [self setType: 5];
                break;
            case 5:
                [self setType: 4];
                break;
        }
    }
    [controller setArrow: type];
}

/*- (void)mouseDragged:(NSEvent *)theEvent {
	NSPoint mouseLocation = [self convertPoint:[theEvent locationInWindow] fromView:nil];

	//[controller setArrowOffset:[self frame].size.width-mouseLocation.origin.x];
	offset = [self frame].size.width-mouseLocation.x;
}*/


@end
